diff --git a/lib/libc/gen/waitpid.c b/lib/libc/gen/waitpid.c
index acc56f8..68620fc 100644
--- a/lib/libc/gen/waitpid.c
+++ b/lib/libc/gen/waitpid.c
@@ -46,7 +46,7 @@
 pid_t
 __waitpid(pid_t pid, int *istat, int options)
 {
-	return (_wait4(pid, istat, options, (struct rusage *)0));
+	return (_wait4(pid, istat, options, NULL));
 }
 
 __weak_reference(__waitpid, waitpid);
diff --git a/lib/libc/gmon/gmon.c b/lib/libc/gmon/gmon.c
index cdf5f1b..f145af1 100644
--- a/lib/libc/gmon/gmon.c
+++ b/lib/libc/gmon/gmon.c
@@ -235,7 +235,7 @@ moncontrol(int mode)
 		p->state = GMON_PROF_ON;
 	} else {
 		/* stop */
-		profil((char *)0, 0, 0, 0);
+		profil(NULL, 0, 0, 0);
 		p->state = GMON_PROF_OFF;
 	}
 }
diff --git a/lib/libc/quad/divdi3.c b/lib/libc/quad/divdi3.c
index 013f44d..f6b9197 100644
--- a/lib/libc/quad/divdi3.c
+++ b/lib/libc/quad/divdi3.c
@@ -58,6 +58,6 @@ __divdi3(quad_t a, quad_t b)
 		ub = -(u_quad_t)b, neg ^= 1;
 	else
 		ub = b;
-	uq = __qdivrem(ua, ub, (u_quad_t *)0);
+	uq = __qdivrem(ua, ub, NULL);
 	return (neg ? -uq : uq);
 }
diff --git a/lib/libc/quad/udivdi3.c b/lib/libc/quad/udivdi3.c
index 6bf9203..37078a8 100644
--- a/lib/libc/quad/udivdi3.c
+++ b/lib/libc/quad/udivdi3.c
@@ -47,5 +47,5 @@ u_quad_t
 __udivdi3(u_quad_t a, u_quad_t b)
 {
 
-	return (__qdivrem(a, b, (u_quad_t *)0));
+	return (__qdivrem(a, b, NULL));
 }
diff --git a/lib/libc/stdlib/malloc.c b/lib/libc/stdlib/malloc.c
index f65c34f..421dc0a 100644
--- a/lib/libc/stdlib/malloc.c
+++ b/lib/libc/stdlib/malloc.c
@@ -285,7 +285,7 @@ static char *malloc_func;
 
 /* Macro for mmap */
 #define MMAP(size) \
-	mmap((void *)0, (size), PROT_READ|PROT_WRITE, MAP_ANON|MAP_PRIVATE, \
+	mmap(NULL, (size), PROT_READ|PROT_WRITE, MAP_ANON|MAP_PRIVATE, \
 	    -1, (off_t)0)
 
 /*
diff --git a/lib/libc/stdlib/system.c b/lib/libc/stdlib/system.c
index d69c650..8cfac5c 100644
--- a/lib/libc/stdlib/system.c
+++ b/lib/libc/stdlib/system.c
@@ -88,7 +88,7 @@ __system(const char *command)
 	default:			/* parent */
 		savedpid = pid;
 		do {
-			pid = _wait4(savedpid, &pstat, 0, (struct rusage *)0);
+			pid = _wait4(savedpid, &pstat, 0, NULL);
 		} while (pid == -1 && errno == EINTR);
 		break;
 	}
diff --git a/lib/libstand/cd9660.c b/lib/libstand/cd9660.c
index 53feaa6..77ceb2c 100644
--- a/lib/libstand/cd9660.c
+++ b/lib/libstand/cd9660.c
@@ -448,7 +448,7 @@ buf_read_file(struct open_file *f, char **buf_p, size_t *size_p)
 	blkoff = fp->f_off % ISO_DEFAULT_BLOCK_SIZE;
 
 	if (blkno != fp->f_buf_blkno) {
-		if (fp->f_buf == (char *)0)
+		if (fp->f_buf == NULL)
 			fp->f_buf = malloc(ISO_DEFAULT_BLOCK_SIZE);
 
 		twiddle();
diff --git a/lib/libstand/ext2fs.c b/lib/libstand/ext2fs.c
index fc0f16a..61b790c 100644
--- a/lib/libstand/ext2fs.c
+++ b/lib/libstand/ext2fs.c
@@ -660,7 +660,7 @@ block_map(struct open_file *f, daddr_t file_block, daddr_t *disk_block_p)
 		}
 
 		if (fp->f_blkno[level] != ind_block_num) {
-			if (fp->f_blk[level] == (char *)0)
+			if (fp->f_blk[level] == NULL)
 				fp->f_blk[level] =
 					malloc(fs->fs_bsize);
 			twiddle();
@@ -714,7 +714,7 @@ buf_read_file(struct open_file *f, char **buf_p, size_t *size_p)
 		if (error)
 			goto done;
 
-		if (fp->f_buf == (char *)0)
+		if (fp->f_buf == NULL)
 			fp->f_buf = malloc(fs->fs_bsize);
 
 		if (disk_block == 0) {
@@ -794,8 +794,8 @@ ext2fs_close(struct open_file *f)
 	struct file *fp = (struct file *)f->f_fsdata;
 	int level;
 
-	f->f_fsdata = (void *)0;
-	if (fp == (struct file *)0)
+	f->f_fsdata = NULL;
+	if (fp == NULL)
 		return (0);
 
 	for (level = 0; level < NIADDR; level++) {
diff --git a/lib/libstand/net.c b/lib/libstand/net.c
index f3b0035..52e26b4 100644
--- a/lib/libstand/net.c
+++ b/lib/libstand/net.c
@@ -259,7 +259,7 @@ ip_convertaddr(char *p)
 #define IP_ANYADDR	0
 	n_long addr = 0, n;
 
-	if (p == (char *)0 || *p == '\0')
+	if (p == NULL || *p == '\0')
 		return IP_ANYADDR;
 	p = number(p, &n);
 	addr |= (n << 24) & 0xff000000;
diff --git a/lib/libstand/netif.c b/lib/libstand/netif.c
index 12b092d..29ac20c 100644
--- a/lib/libstand/netif.c
+++ b/lib/libstand/netif.c
@@ -278,7 +278,7 @@ netif_open(void *machdep_hint)
 	
 	/* find a free socket */
 	for (fd = 0, s = sockets; fd < SOPEN_MAX; fd++, s++)
-		if (s->io_netif == (struct netif *)0)
+		if (s->io_netif == NULL)
 			goto fnd;
 	errno = EMFILE;
 	return (-1);
@@ -308,7 +308,7 @@ netif_close(int sock)
 		return(-1);
 	}
 	netif_detach(sockets[sock].io_netif);
-	sockets[sock].io_netif = (struct netif *)0;
+	sockets[sock].io_netif = NULL;
 
 	return(0);
 }
diff --git a/lib/libstand/open.c b/lib/libstand/open.c
index 90b603e..5547c8e 100644
--- a/lib/libstand/open.c
+++ b/lib/libstand/open.c
@@ -103,15 +103,15 @@ open(const char *fname, int mode)
 
     f = &files[fd];
     f->f_flags = mode + 1;
-    f->f_dev = (struct devsw *)0;
-    f->f_ops = (struct fs_ops *)0;
+    f->f_dev = NULL;
+    f->f_ops = NULL;
     f->f_offset = 0;
     f->f_devdata = NULL;
     f->f_fsdata = NULL;
     file = NULL;
     error = devopen(f, fname, &file);
     if (error ||
-	(((f->f_flags & F_NODEV) == 0) && f->f_dev == (struct devsw *)0))
+	(((f->f_flags & F_NODEV) == 0) && f->f_dev == NULL))
 	goto err;
 
     /* see if we opened a raw device; otherwise, 'file' is the file name. */
diff --git a/lib/libstand/qdivrem.c b/lib/libstand/qdivrem.c
index d6ca6f9..78b450c 100644
--- a/lib/libstand/qdivrem.c
+++ b/lib/libstand/qdivrem.c
@@ -285,7 +285,7 @@ u_quad_t
 __udivdi3(u_quad_t a, u_quad_t b)
 {
 
-	return (__qdivrem(a, b, (u_quad_t *)0));
+	return (__qdivrem(a, b, NULL));
 }
 
 /*
diff --git a/lib/libstand/ufs.c b/lib/libstand/ufs.c
index 3f2afa1..a47a5aa 100644
--- a/lib/libstand/ufs.c
+++ b/lib/libstand/ufs.c
@@ -250,7 +250,7 @@ block_map(struct open_file *f, daddr_t file_block, daddr_t *disk_block_p)
 		}
 
 		if (fp->f_blkno[level] != ind_block_num) {
-			if (fp->f_blk[level] == (char *)0)
+			if (fp->f_blk[level] == NULL)
 				fp->f_blk[level] =
 					malloc(fs->fs_bsize);
 			twiddle();
@@ -310,7 +310,7 @@ buf_read_file(struct open_file *f, char **buf_p, size_t *size_p)
 		if (rc)
 			return (rc);
 
-		if (fp->f_buf == (char *)0)
+		if (fp->f_buf == NULL)
 			fp->f_buf = malloc(fs->fs_bsize);
 
 		if (disk_block == 0) {
diff --git a/lib/libvgl/main.c b/lib/libvgl/main.c
index 864d535..d9cfbfa 100644
--- a/lib/libvgl/main.c
+++ b/lib/libvgl/main.c
@@ -278,7 +278,7 @@ VGLInit(int mode)
     VGLEnd();
     return -9;
   }
-  VGLTextSetFontFile((byte*)0);
+  VGLTextSetFontFile(NULL);
   VGLClear(VGLDisplay, 0);
   return 0;
 }
diff --git a/lib/libvgl/text.c b/lib/libvgl/text.c
index 61c7293..5c91125 100644
--- a/lib/libvgl/text.c
+++ b/lib/libvgl/text.c
@@ -48,7 +48,7 @@ FILE *fd;
     free(VGLTextFont);
   }
 
-  if ((VGLTextFont=(VGLText*)malloc(sizeof(VGLText))) == (VGLText*)0)
+  if ((VGLTextFont=(VGLText*)malloc(sizeof(VGLText))) == NULL)
 	return 1;
 
   if (filename==NULL) {
@@ -57,7 +57,7 @@ FILE *fd;
     VGLTextFont->BitmapArray = VGLFont;
   }
   else {
-    if ((fd=fopen(filename, "r"))==(FILE*)0)
+    if ((fd=fopen(filename, "r"))==NULL)
       return 1;
     fread(&VGLTextFont->Width, 1 , 1, fd);
     fread(&VGLTextFont->Height, 1 , 1, fd);
diff --git a/libexec/getty/main.c b/libexec/getty/main.c
index 942fb98..cd77f4c 100644
--- a/libexec/getty/main.c
+++ b/libexec/getty/main.c
@@ -388,7 +388,7 @@ main(int argc, char **argv)
 				exit(1);
 			}
 			signal(SIGINT, SIG_DFL);
-			for (i = 0; environ[i] != (char *)0; i++)
+			for (i = 0; environ[i] != NULL; i++)
 				env[i] = environ[i];
 			makeenv(&env[i]);
 
diff --git a/libexec/getty/subr.c b/libexec/getty/subr.c
index bcb33aa..287fe44 100644
--- a/libexec/getty/subr.c
+++ b/libexec/getty/subr.c
@@ -734,7 +734,7 @@ makeenv(char *env[])
 		if (*p)
 			*ep++ = p;
 	}
-	*ep = (char *)0;
+	*ep = NULL;
 }
 
 /*
diff --git a/libexec/rbootd/rbootd.c b/libexec/rbootd/rbootd.c
index a4484c1..6f8f432 100644
--- a/libexec/rbootd/rbootd.c
+++ b/libexec/rbootd/rbootd.c
@@ -304,7 +304,7 @@ DoTimeout()
 	RMPCONN *rtmp;
 	struct timeval now;
 
-	(void) gettimeofday(&now, (struct timezone *)0);
+	(void) gettimeofday(&now, NULL);
 
 	/*
 	 *  For each active connection, if RMP_TIMEOUT seconds have passed
diff --git a/libexec/rbootd/rmpproto.c b/libexec/rbootd/rmpproto.c
index 5bc87e3..31985ed 100644
--- a/libexec/rbootd/rmpproto.c
+++ b/libexec/rbootd/rmpproto.c
@@ -582,7 +582,7 @@ SendPacket(rconn)
 	/*
 	 *  Last time this connection was active.
 	 */
-	(void) gettimeofday(&rconn->tstamp, (struct timezone *)0);
+	(void) gettimeofday(&rconn->tstamp, NULL);
 
 	if (DbgFp != NULL)			/* display packet */
 		DispPkt(rconn,DIR_SENT);
diff --git a/libexec/revnetgroup/parse_netgroup.c b/libexec/revnetgroup/parse_netgroup.c
index 3e09974..5b90887 100644
--- a/libexec/revnetgroup/parse_netgroup.c
+++ b/libexec/revnetgroup/parse_netgroup.c
@@ -73,14 +73,14 @@ struct netgrp {
 #define NG_USER		1	/* User name */
 #define NG_DOM		2	/* and Domain name */
 
-static struct linelist	*linehead = (struct linelist *)0;
-static struct netgrp	*nextgrp = (struct netgrp *)0;
+static struct linelist	*linehead = NULL;
+static struct netgrp	*nextgrp = NULL;
 static struct {
 	struct netgrp	*gr;
 	char		*grname;
 } grouphead = {
-	(struct netgrp *)0,
-	(char *)0,
+	NULL,
+	NULL,
 };
 static int parse_netgrp(char *);
 static struct linelist *read_for_group(char *);
@@ -100,7 +100,7 @@ __setnetgrent(char *group)
 	if (group == NULL || !strlen(group))
 		return;
 
-	if (grouphead.gr == (struct netgrp *)0 ||
+	if (grouphead.gr == NULL ||
 		strcmp(group, grouphead.grname)) {
 		__endnetgrent();
 		if (parse_netgrp(group))
@@ -147,10 +147,10 @@ __endnetgrent(void)
 		free(olp->l_line);
 		free((char *)olp);
 	}
-	linehead = (struct linelist *)0;
+	linehead = NULL;
 	if (grouphead.grname) {
 		free(grouphead.grname);
-		grouphead.grname = (char *)0;
+		grouphead.grname = NULL;
 	}
 	gp = grouphead.gr;
 	while (gp) {
@@ -164,7 +164,7 @@ __endnetgrent(void)
 			free(ogp->ng_str[NG_DOM]);
 		free((char *)ogp);
 	}
-	grouphead.gr = (struct netgrp *)0;
+	grouphead.gr = NULL;
 }
 
 /*
@@ -190,8 +190,8 @@ parse_netgrp(char *group)
 			break;
 		lp = lp->l_next;
 	}
-	if (lp == (struct linelist *)0 &&
-	    (lp = read_for_group(group)) == (struct linelist *)0)
+	if (lp == NULL &&
+	    (lp = read_for_group(group)) == NULL)
 		return (1);
 	if (lp->l_parsed) {
 #ifdef DEBUG
@@ -357,5 +357,5 @@ read_for_group(char *group)
 #endif
 			return (lp);
 	}
-	return ((struct linelist *)0);
+	return (NULL);
 }
diff --git a/libexec/rshd/rshd.c b/libexec/rshd/rshd.c
index 5721999..e53d148 100644
--- a/libexec/rshd/rshd.c
+++ b/libexec/rshd/rshd.c
@@ -500,8 +500,8 @@ fail:
 						break;
 				} else
 #endif
-					if (select(nfd, &ready, (fd_set *)0,
-					  (fd_set *)0, (struct timeval *)0) < 0)
+					if (select(nfd, &ready, NULL,
+					  NULL, NULL) < 0)
 						break;
 				if (FD_ISSET(s, &ready)) {
 					int	ret;
diff --git a/libexec/rtld-elf/rtld.c b/libexec/rtld-elf/rtld.c
index 9e677ca..eddf1dc 100644
--- a/libexec/rtld-elf/rtld.c
+++ b/libexec/rtld-elf/rtld.c
@@ -1970,7 +1970,7 @@ dladdr(const void *addr, Dl_info *info)
     }
     info->dli_fname = obj->path;
     info->dli_fbase = obj->mapbase;
-    info->dli_saddr = (void *)0;
+    info->dli_saddr = NULL;
     info->dli_sname = NULL;
 
     /*
diff --git a/libexec/talkd/process.c b/libexec/talkd/process.c
index 88ceb46..17f160c 100644
--- a/libexec/talkd/process.c
+++ b/libexec/talkd/process.c
@@ -116,7 +116,7 @@ process_request(mp, rp)
 
 	case LEAVE_INVITE:
 		ptr = find_request(mp);
-		if (ptr != (CTL_MSG *)0) {
+		if (ptr != NULL) {
 			rp->id_num = htonl(ptr->id_num);
 			rp->answer = SUCCESS;
 		} else
@@ -125,7 +125,7 @@ process_request(mp, rp)
 
 	case LOOK_UP:
 		ptr = find_match(mp);
-		if (ptr != (CTL_MSG *)0) {
+		if (ptr != NULL) {
 			rp->id_num = htonl(ptr->id_num);
 			rp->addr = ptr->addr;
 			rp->addr.sa_family = htons(ptr->addr.sa_family);
@@ -164,7 +164,7 @@ do_announce(mp, rp)
 #define	satosin(sa)	((struct sockaddr_in *)(sa))
 	hp = gethostbyaddr(&satosin(&mp->ctl_addr)->sin_addr,
 		sizeof (struct in_addr), AF_INET);
-	if (hp == (struct hostent *)0) {
+	if (hp == NULL) {
 		rp->answer = MACHINE_UNKNOWN;
 		return;
 	}
diff --git a/libexec/talkd/table.c b/libexec/talkd/table.c
index 5fea450..9ab5cfe 100644
--- a/libexec/talkd/table.c
+++ b/libexec/talkd/table.c
@@ -55,8 +55,6 @@
 
 #define MAX_ID 16000	/* << 2^15 so I don't have sign troubles */
 
-#define NIL ((TABLE_ENTRY *)0)
-
 extern	int debug;
 struct	timeval tp;
 struct	timezone txp;
@@ -70,7 +68,7 @@ struct table_entry {
 	TABLE_ENTRY *last;
 };
 
-TABLE_ENTRY *table = NIL;
+TABLE_ENTRY *table = NULL;
 
 void delete (TABLE_ENTRY *);
 CTL_MSG *find_request();
@@ -93,7 +91,7 @@ find_match(request)
 	current_time = tp.tv_sec;
 	if (debug)
 		print_request("find_match", request);
-	for (ptr = table; ptr != NIL; ptr = ptr->next) {
+	for (ptr = table; ptr != NULL; ptr = ptr->next) {
 		if ((ptr->time - current_time) > MAX_LIFE) {
 			/* the entry is too old */
 			if (debug)
@@ -109,7 +107,7 @@ find_match(request)
 		     ptr->request.type == LEAVE_INVITE)
 			return (&ptr->request);
 	}
-	return ((CTL_MSG *)0);
+	return (NULL);
 }
 
 /*
@@ -131,7 +129,7 @@ find_request(request)
 	 */
 	if (debug)
 		print_request("find_request", request);
-	for (ptr = table; ptr != NIL; ptr = ptr->next) {
+	for (ptr = table; ptr != NULL; ptr = ptr->next) {
 		if ((ptr->time - current_time) > MAX_LIFE) {
 			/* the entry is too old */
 			if (debug)
@@ -151,7 +149,7 @@ find_request(request)
 			return (&ptr->request);
 		}
 	}
-	return ((CTL_MSG *)0);
+	return (NULL);
 }
 
 void
@@ -168,16 +166,16 @@ insert_table(request, response)
 	response->id_num = htonl(request->id_num);
 	/* insert a new entry into the top of the list */
 	ptr = (TABLE_ENTRY *)malloc(sizeof(TABLE_ENTRY));
-	if (ptr == NIL) {
+	if (ptr == NULL) {
 		syslog(LOG_ERR, "insert_table: Out of memory");
 		_exit(1);
 	}
 	ptr->time = current_time;
 	ptr->request = *request;
 	ptr->next = table;
-	if (ptr->next != NIL)
+	if (ptr->next != NULL)
 		ptr->next->last = ptr;
-	ptr->last = NIL;
+	ptr->last = NULL;
 	table = ptr;
 }
 
@@ -208,13 +206,13 @@ delete_invite(id_num)
 	ptr = table;
 	if (debug)
 		syslog(LOG_DEBUG, "delete_invite(%d)", id_num);
-	for (ptr = table; ptr != NIL; ptr = ptr->next) {
+	for (ptr = table; ptr != NULL; ptr = ptr->next) {
 		if (ptr->request.id_num == id_num)
 			break;
 		if (debug)
 			print_request("", &ptr->request);
 	}
-	if (ptr != NIL) {
+	if (ptr != NULL) {
 		delete(ptr);
 		return (SUCCESS);
 	}
@@ -233,9 +231,9 @@ delete(ptr)
 		print_request("delete", &ptr->request);
 	if (table == ptr)
 		table = ptr->next;
-	else if (ptr->last != NIL)
+	else if (ptr->last != NULL)
 		ptr->last->next = ptr->next;
-	if (ptr->next != NIL)
+	if (ptr->next != NULL)
 		ptr->next->last = ptr->last;
 	free((char *)ptr);
 }
diff --git a/libexec/telnetd/slc.c b/libexec/telnetd/slc.c
index 06aea4a..568d8b7 100644
--- a/libexec/telnetd/slc.c
+++ b/libexec/telnetd/slc.c
@@ -41,7 +41,7 @@
 /*
  * local variables
  */
-static unsigned char	*def_slcbuf = (unsigned char *)0;
+static unsigned char	*def_slcbuf = NULL;
 static int		def_slclen = 0;
 static int		slcchange;	/* change to slc is requested */
 static unsigned char	*slcptr;	/* pointer into slc buffer */
@@ -447,10 +447,10 @@ do_opt_slc(unsigned char *ptr, int len)
 		 * save this slc buffer if it is the first, otherwise dump
 		 * it.
 		 */
-		if (def_slcbuf == (unsigned char *)0) {
+		if (def_slcbuf == NULL) {
 			def_slclen = len;
 			def_slcbuf = (unsigned char *)malloc((unsigned)len);
-			if (def_slcbuf == (unsigned char *)0)
+			if (def_slcbuf == NULL)
 				return;  /* too bad */
 			memmove(def_slcbuf, ptr, len);
 		}
@@ -471,7 +471,7 @@ deferslc(void)
 		do_opt_slc(def_slcbuf, def_slclen);
 		(void) end_slc(0);
 		free(def_slcbuf);
-		def_slcbuf = (unsigned char *)0;
+		def_slcbuf = NULL;
 		def_slclen = 0;
 	}
 
diff --git a/libexec/telnetd/sys_term.c b/libexec/telnetd/sys_term.c
index 60cb0de..569731b 100644
--- a/libexec/telnetd/sys_term.c
+++ b/libexec/telnetd/sys_term.c
@@ -273,11 +273,11 @@ spcset(int func, cc_t *valp, cc_t **valpp)
 	case SLC_AYT:
 	case SLC_EOR:
 		*valp = (cc_t)0;
-		*valpp = (cc_t *)0;
+		*valpp = NULL;
 		return(SLC_DEFAULT);
 	default:
 		*valp = (cc_t)0;
-		*valpp = (cc_t *)0;
+		*valpp = NULL;
 		return(SLC_NOSUPPORT);
 	}
 }
@@ -288,7 +288,7 @@ spcset(int func, cc_t *valp, cc_t **valpp)
 #define	setval(a, b)	*valp = termbuf.c_cc[a]; \
 			*valpp = &termbuf.c_cc[a]; \
 			return(b);
-#define	defval(a) *valp = ((cc_t)a); *valpp = (cc_t *)0; return(SLC_DEFAULT);
+#define	defval(a) *valp = ((cc_t)a); *valpp = NULL; return(SLC_DEFAULT);
 
 int
 spcset(int func, cc_t *valp, cc_t **valpp)
@@ -868,7 +868,7 @@ getptyslave(void)
 # ifdef	TIOCNOTTY
 	t = open(_PATH_TTY, O_RDWR);
 	if (t >= 0) {
-		(void) ioctl(t, TIOCNOTTY, (char *)0);
+		(void) ioctl(t, TIOCNOTTY, NULL);
 		(void) close(t);
 	}
 # endif
@@ -1094,7 +1094,7 @@ addarg(char **argv, const char *val)
 		if (argv == NULL)
 			return(NULL);
 		*argv++ = (char *)10;
-		*argv = (char *)0;
+		*argv = NULL;
 	}
 	for (cpp = argv; *cpp; cpp++)
 		;
diff --git a/libexec/telnetd/telnetd.c b/libexec/telnetd/telnetd.c
index 744a0ba..10d810b 100644
--- a/libexec/telnetd/telnetd.c
+++ b/libexec/telnetd/telnetd.c
@@ -758,7 +758,7 @@ telnet(int f, int p, char *host)
 		int t;
 		t = open(_PATH_TTY, O_RDWR);
 		if (t >= 0) {
-			(void) ioctl(t, TIOCNOTTY, (char *)0);
+			(void) ioctl(t, TIOCNOTTY, NULL);
 			(void) close(t);
 		}
 	}
@@ -839,8 +839,7 @@ telnet(int f, int p, char *host)
 		if (!SYNCHing) {
 			FD_SET(f, &xbits);
 		}
-		if ((c = select(nfd, &ibits, &obits, &xbits,
-						(struct timeval *)0)) < 1) {
+		if ((c = select(nfd, &ibits, &obits, &xbits, NULL)) < 1) {
 			if (c == -1) {
 				if (errno == EINTR) {
 					continue;
diff --git a/libexec/telnetd/utility.c b/libexec/telnetd/utility.c
index db9d52e..473834d 100644
--- a/libexec/telnetd/utility.c
+++ b/libexec/telnetd/utility.c
@@ -96,7 +96,7 @@ stilloob(int s)
 	FD_ZERO(&excepts);
 	FD_SET(s, &excepts);
 	memset((char *)&timeout, 0, sizeof timeout);
-	value = select(s+1, (fd_set *)0, (fd_set *)0, &excepts, &timeout);
+	value = select(s+1, NULL, NULL, &excepts, &timeout);
     } while ((value == -1) && (errno == EINTR));
 
     if (value < 0) {
diff --git a/sbin/atm/atm/atm_show.c b/sbin/atm/atm/atm_show.c
index 7ee3a60..c183649 100644
--- a/sbin/atm/atm/atm_show.c
+++ b/sbin/atm/atm/atm_show.c
@@ -398,7 +398,7 @@ void
 show_ip_vcc(int argc, char **argv, __unused const struct cmd *cmdp)
 {
 	int			buf_len, ip_info_len, rc;
-	char			*if_name = (char *)0;
+	char			*if_name = NULL;
 	struct atminfreq	air;
 	struct air_ip_vcc_rsp	*ip_info, *ip_info_base;
 	struct sockaddr_in	*sin;
diff --git a/sbin/disklabel/disklabel.c b/sbin/disklabel/disklabel.c
index 75baf14..bec4f33 100644
--- a/sbin/disklabel/disklabel.c
+++ b/sbin/disklabel/disklabel.c
@@ -815,9 +815,9 @@ editit(void)
 		sigsetmask(omask);
 		setgid(getgid());
 		setuid(getuid());
-		if ((ed = getenv("EDITOR")) == (char *)0)
+		if ((ed = getenv("EDITOR")) == NULL)
 			ed = DEFEDITOR;
-		execlp(ed, ed, tmpfil, (char *)0);
+		execlp(ed, ed, tmpfil, NULL);
 		err(1, "%s", ed);
 	}
 	while ((xpid = wait(&status)) >= 0)
diff --git a/sbin/disklabel64/disklabel64.c b/sbin/disklabel64/disklabel64.c
index d6b1b01..d765994 100644
--- a/sbin/disklabel64/disklabel64.c
+++ b/sbin/disklabel64/disklabel64.c
@@ -822,9 +822,9 @@ editit(void)
 		sigsetmask(omask);
 		setgid(getgid());
 		setuid(getuid());
-		if ((ed = getenv("EDITOR")) == (char *)0)
+		if ((ed = getenv("EDITOR")) == NULL)
 			ed = DEFEDITOR;
-		execlp(ed, ed, tmpfil, (char *)0);
+		execlp(ed, ed, tmpfil, NULL);
 		err(1, "%s", ed);
 	}
 	while ((xpid = wait(&status)) >= 0)
diff --git a/sbin/dump/dumprmt.c b/sbin/dump/dumprmt.c
index e914772..677a6d8 100644
--- a/sbin/dump/dumprmt.c
+++ b/sbin/dump/dumprmt.c
@@ -167,8 +167,7 @@ rmtgetconn(void)
 	msg("%s", "");
 #ifdef KERBEROS
 	if (dokerberos)
-		rmtape = krcmd(&rmtpeer, sp->s_port, tuser, rmt, &errfd,
-			       (char *)0);
+		rmtape = krcmd(&rmtpeer, sp->s_port, tuser, rmt, &errfd, NULL);
 	else
 #endif
 		rmtape = rcmd(&rmtpeer, (u_short)sp->s_port, pwd->pw_name,
diff --git a/sbin/dumpon/dumpon.c b/sbin/dumpon/dumpon.c
index ca2bcce..36cad43 100644
--- a/sbin/dumpon/dumpon.c
+++ b/sbin/dumpon/dumpon.c
@@ -88,8 +88,7 @@ main(int argc, char **argv)
 	mib[0] = CTL_KERN;
 	mib[1] = KERN_DUMPDEV;
 
-	rv = sysctl(mib, 2, (void *)0, (size_t *)0, &stab.st_rdev,
-		    sizeof stab.st_rdev);
+	rv = sysctl(mib, 2, NULL, NULL, &stab.st_rdev, sizeof stab.st_rdev);
 	if (rv) {
 		err(EX_OSERR, "sysctl: kern.dumpdev");
 	}
diff --git a/sbin/fsck/inode.c b/sbin/fsck/inode.c
index 15a0020..16f1fbf 100644
--- a/sbin/fsck/inode.c
+++ b/sbin/fsck/inode.c
@@ -416,7 +416,7 @@ getinoinfo(ufs1_ino_t inumber)
 		return (inp);
 	}
 	errx(EEXIT, "cannot find inode %d", inumber);
-	return ((struct inoinfo *)0);
+	return (NULL);
 }
 
 /*
diff --git a/sbin/fsck/main.c b/sbin/fsck/main.c
index 1159dc0..8e5e4ac 100644
--- a/sbin/fsck/main.c
+++ b/sbin/fsck/main.c
@@ -312,9 +312,9 @@ checkfilesys(char *filesys, char *mntpt, long auxdata, int child)
 			printf("\n");
 		}
 	}
-	zlnhead = (struct zlncnt *)0;
-	duplist = (struct dups *)0;
-	muldup = (struct dups *)0;
+	zlnhead = NULL;
+	duplist = NULL;
+	muldup = NULL;
 	inocleanup();
 	if (fsmodified) {
 		sblock.fs_time = time(NULL);
diff --git a/sbin/fsck/utilities.c b/sbin/fsck/utilities.c
index fd35817..19b1f4a 100644
--- a/sbin/fsck/utilities.c
+++ b/sbin/fsck/utilities.c
@@ -137,7 +137,7 @@ bufinit(void)
 	long bufcnt, i;
 	char *bufp;
 
-	pbp = pdirbp = (struct bufarea *)0;
+	pbp = pdirbp = NULL;
 	bufp = malloc((unsigned int)sblock.fs_bsize);
 	if (bufp == 0)
 		errx(EEXIT, "cannot allocate buffer pool");
@@ -273,7 +273,7 @@ ckfini(int markclean)
 	}
 	if (bufhead.b_size != cnt)
 		errx(EEXIT, "panic: lost %d buffers", bufhead.b_size - cnt);
-	pbp = pdirbp = (struct bufarea *)0;
+	pbp = pdirbp = NULL;
 	if (sblock.fs_clean != markclean) {
 		sblock.fs_clean = markclean;
 		sbdirty();
diff --git a/sbin/init/init.c b/sbin/init/init.c
index b0095c5..0a749f1 100644
--- a/sbin/init/init.c
+++ b/sbin/init/init.c
@@ -310,8 +310,8 @@ invalid:
 	sigemptyset(&sa.sa_mask);
 	sa.sa_flags = 0;
 	sa.sa_handler = SIG_IGN;
-	sigaction(SIGTTIN, &sa, (struct sigaction *)0);
-	sigaction(SIGTTOU, &sa, (struct sigaction *)0);
+	sigaction(SIGTTIN, &sa, NULL);
+	sigaction(SIGTTOU, &sa, NULL);
 
 	/*
 	 * Paranoia.
@@ -762,8 +762,8 @@ runcom(void)
 		sigemptyset(&sa.sa_mask);
 		sa.sa_flags = 0;
 		sa.sa_handler = SIG_IGN;
-		sigaction(SIGTSTP, &sa, (struct sigaction *)0);
-		sigaction(SIGHUP, &sa, (struct sigaction *)0);
+		sigaction(SIGTSTP, &sa, NULL);
+		sigaction(SIGHUP, &sa, NULL);
 
 		setctty(_PATH_CONSOLE);
 
@@ -1456,7 +1456,7 @@ death(void)
 		clang = 0;
 		alarm(DEATH_WATCH);
 		do
-			if ((pid = waitpid(-1, (int *)0, 0)) != -1)
+			if ((pid = waitpid(-1, NULL, 0)) != -1)
 				collect_child(pid);
 		while (clang == 0 && errno != ECHILD);
 
@@ -1506,8 +1506,8 @@ runshutdown(void)
 		sigemptyset(&sa.sa_mask);
 		sa.sa_flags = 0;
 		sa.sa_handler = SIG_IGN;
-		sigaction(SIGTSTP, &sa, (struct sigaction *)0);
-		sigaction(SIGHUP, &sa, (struct sigaction *)0);
+		sigaction(SIGTSTP, &sa, NULL);
+		sigaction(SIGHUP, &sa, NULL);
 
 		if ((fd = open(_PATH_CONSOLE, O_RDWR)) == -1)
 		    warning("can't open %s: %m", _PATH_CONSOLE);
diff --git a/sbin/mount_nfs/mount_nfs.c b/sbin/mount_nfs/mount_nfs.c
index 571a051..9453be8 100644
--- a/sbin/mount_nfs/mount_nfs.c
+++ b/sbin/mount_nfs/mount_nfs.c
@@ -118,11 +118,11 @@ struct mntopt mopts[] = {
 
 struct nfs_args nfsdefargs = {
 	NFS_ARGSVERSION,
-	(struct sockaddr *)0,
+	NULL,
 	sizeof (struct sockaddr_in),
 	SOCK_DGRAM,
 	0,
-	(u_char *)0,
+	NULL,
 	0,
 	NFSMNT_RESVPORT,
 	NFS_WSIZE,
@@ -134,7 +134,7 @@ struct nfs_args nfsdefargs = {
 	NFS_DEFRAHEAD,
 	0,
 	NFS_DEADTHRESH,
-	(char *)0,
+	NULL,
 	/* args version 4 */
 	NFS_MINATTRTIMO,
 	NFS_MAXATTRTIMO,
@@ -538,7 +538,7 @@ main(int argc, char **argv)
 			 */
 			if (kret == KSUCCESS &&
 			    ktick.kt.length <= (RPCAUTH_MAXSIZ-3*NFSX_UNSIGNED)
-			    && gettimeofday(&ktv, (struct timezone *)0) == 0) {
+			    && gettimeofday(&ktv, NULL) == 0) {
 			    ncd.ncd_authtype = RPCAUTH_KERB4;
 			    ncd.ncd_authstr = (u_char *)&ktick;
 			    ncd.ncd_authlen = nfsm_rndup(ktick.kt.length) +
diff --git a/sbin/mount_portal/pt_tcplisten.c b/sbin/mount_portal/pt_tcplisten.c
index 522cfc7..68256e9 100644
--- a/sbin/mount_portal/pt_tcplisten.c
+++ b/sbin/mount_portal/pt_tcplisten.c
@@ -157,7 +157,7 @@ portal_tcplisten(struct portal_cred *pcr, char *key, char **v, int kso,
                sain.sin_addr.s_addr = INADDR_ANY;
                if (bind(so, (struct sockaddr *) &sain, sizeof(sain)) == 0) {
                        listen(so, 1);
-                       if ((sock = accept(so, (struct sockaddr *)0, (int *)0)) == -1) {
+                       if ((sock = accept(so, NULL, NULL)) == -1) {
                                syslog(LOG_ERR, "accept: %m");
                                close(so);
                                return (errno);
@@ -184,7 +184,7 @@ portal_tcplisten(struct portal_cred *pcr, char *key, char **v, int kso,
                sain.sin_addr = *ipp[0];
                if (bind(so, (struct sockaddr *) &sain, sizeof(sain)) == 0) {
                        listen(so, 1);
-                       if ((sock = accept(so, (struct sockaddr *)0, (int *)0)) == -1) {
+                       if ((sock = accept(so, NULL, NULL)) == -1) {
                                syslog(LOG_ERR, "accept: %m");
                                close(so);
                                return (errno);
diff --git a/sbin/quotacheck/quotacheck.c b/sbin/quotacheck/quotacheck.c
index bf96ada..7835557 100644
--- a/sbin/quotacheck/quotacheck.c
+++ b/sbin/quotacheck/quotacheck.c
@@ -267,7 +267,7 @@ chkquota(char *fsname, char *mntpt, struct quotaname *qnp)
 				continue;
 			if (qnp->flags & HASGRP) {
 				fup = addid((u_long)dp->di_gid, GRPQUOTA,
-				    (char *)0);
+				    NULL);
 				fup->fu_curinodes++;
 				if (mode == IFREG || mode == IFDIR ||
 				    mode == IFLNK)
@@ -275,7 +275,7 @@ chkquota(char *fsname, char *mntpt, struct quotaname *qnp)
 			}
 			if (qnp->flags & HASUSR) {
 				fup = addid((u_long)dp->di_uid, USRQUOTA,
-				    (char *)0);
+				    NULL);
 				fup->fu_curinodes++;
 				if (mode == IFREG || mode == IFDIR ||
 				    mode == IFLNK)
diff --git a/sbin/restore/main.c b/sbin/restore/main.c
index 4bcc368..1f665d1 100644
--- a/sbin/restore/main.c
+++ b/sbin/restore/main.c
@@ -209,7 +209,7 @@ main(int argc, char **argv)
 			 * This is a level zero dump tape.
 			 */
 			vprintf(stdout, "Begin level 0 restore\n");
-			initsymtable((char *)0);
+			initsymtable(NULL);
 			extractdirs(1);
 			vprintf(stdout, "Calculate extraction list.\n");
 			treescan(".", ROOTINO, nodeupdates);
@@ -243,7 +243,7 @@ main(int argc, char **argv)
 	case 't':
 		setup();
 		extractdirs(0);
-		initsymtable((char *)0);
+		initsymtable(NULL);
 		while (argc--) {
 			canon(*argv++, name, sizeof(name));
 			ino = dirlookup(name);
@@ -258,7 +258,7 @@ main(int argc, char **argv)
 	case 'x':
 		setup();
 		extractdirs(1);
-		initsymtable((char *)0);
+		initsymtable(NULL);
 		while (argc--) {
 			canon(*argv++, name, sizeof(name));
 			ino = dirlookup(name);
diff --git a/sbin/slattach/slattach.c b/sbin/slattach/slattach.c
index f98727c..cd3880d 100644
--- a/sbin/slattach/slattach.c
+++ b/sbin/slattach/slattach.c
@@ -72,7 +72,7 @@ static void acquire_line(void);		/* get tty device as controlling terminal */
 static void usage(void);
 
 int	fd = -1;
-char	*dev = (char *)0;	/* path name of the tty (e.g. /dev/tty01) */
+char	*dev = NULL;	/* path name of the tty (e.g. /dev/tty01) */
 char    *dvname;                /* basename of dev */
 int     locked = 0;             /* uucp lock active */
 int	flow_control = 0;	/* non-zero to enable hardware flow control. */
@@ -174,7 +174,7 @@ main(int argc, char **argv)
 	    warnx("too many args, first='%s'", argv[optind]);
 	if (optind > (argc - 1))
 	    warnx("not enough args");
-	if (dev == (char *)0) {
+	if (dev == NULL) {
 		usage();
 		exit_handler(2);
 	}
diff --git a/sys/conf/nfsswapkernel.c b/sys/conf/nfsswapkernel.c
index 28833c5..7161369 100644
--- a/sys/conf/nfsswapkernel.c
+++ b/sys/conf/nfsswapkernel.c
@@ -67,8 +67,8 @@ struct nfs_diskless nfs_diskless = {
  	},
 	{ 0x10, 0x2, { 0x0, 0x0, 0x83, 0x68, 0x30, 0x12, } },
 	{
-	  (struct sockaddr *)0, SOCK_DGRAM, 0, (nfsv2fh_t *)0,
-	  0, 8192, 8192, 10, 100, (char *)0,
+	  NULL, SOCK_DGRAM, 0, NULL,
+	  0, 8192, 8192, 10, 100, NULL,
 	},
 	{
 		0xf,
@@ -107,8 +107,8 @@ struct nfs_diskless nfs_diskless = {
 	{ 0x10, 0x2, { 0x8, 0x1, 0x83, 0x68, 0x30, 0x5, } },
 	"happy",
 	{
-	  (struct sockaddr *)0, SOCK_DGRAM, 0, (nfsv2fh_t *)0,
-	  0, 8192, 8192, 10, 100, (char *)0,
+	  NULL, SOCK_DGRAM, 0, NULL,
+	  0, 8192, 8192, 10, 100, NULL,
 	},
 	{
 		0x0,
